<?php

namespace App\Http\Middleware\Board;

use Closure;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Gate;
use App\Services\BoardService;
use App\Services\PostService;

class PostDownload
{
    public function handle(Request $request, Closure $next)
    {
        $code = $request->route('code');
        $postID = $request->route('postID');

        // 게시판 코드 확인
        if (!$code || !$postID) {
            abort(404);
        }

        $boardService = new BoardService();

        // 게시판 정보 조회
        $board = $boardService->find($code);

        // 게시판 존재 유무
        if (!$board->exists) {
            return alert('존재하지 않는 게시판 입니다.', DIRECTORY_SEPARATOR);
        }

        // 게시판 사용 여부
        if ($board->is_display == 0) {
            return alert('더 이상 사용하지 않는 게시판 입니다.', DIRECTORY_SEPARATOR);
        }

        $postService = new PostService();

        // 게시글 조회
        $post = $postService->find($postID);

        if(!$post->exists) {
            return alert('존재하지 않는 게시글입니다.');
        }

        $user = $request->user();

        // 비회원 게시글은 비밀번호 확인
        if(!$user && !$post->user_id) {
            $passwd = $request->input('passwd');
            if(!$passwd || $passwd != $post->password) {
                return alert('권한이 없습니다.');
            }
        }

        $boardMeta = $boardService->meta($board->id);
        $postViewURL = route('board.post.view', [$code, $postID]);

        // 다운로드 권한 확인
        $response = Gate::inspect('download', [$post, $boardMeta]);
        if($response->denied()) {
            if($response->code() == 401) {
                return loginCheck($postViewURL);
            }else{
                return alert($response->message());
            }
        }

        $request->merge([
            'board' => $board,
            'boardMeta' => $boardMeta,
            'post' => $post
        ]);

        return $next($request);
    }
}
